<?php

// Survey database interface class as intermediate for storing data from the site to the RDF database 
require_once 'rdfConstants.php';

// Include RAP Library to write RDF files
include(RDFAPI_INCLUDE_DIR . "RDFAPI.php");



class SessionCreationDatabaseInterface
{		
    protected $sessionRDFWriter;
    protected $sessionRDFReader;


    public function __construct($sessionID)
    {
        if($sessionID == null)
            $sessionUID = md5( uniqid(rand(), true) );
        else
            $sessionUID = $sessionID;

        $this->sessionRDFWriter = new SessionRDFWriter($sessionUID);
        $this->sessionRDFReader = new SessionRDFReader($sessionUID);
    }
    
    public function setSessionInfo($session)
    {
        $sTitle = $session['sessionTitle'];
        $sDescription = $session['sessionDescription'];

        $this->sessionRDFWriter->createSession($sTitle,$sDescription);
        
        $pipelineCount = $session['pipelineCount'];
        
        for($i = 1; $i <= $pipelineCount; $i++)
        {
            if(isset($session[$i.'s']))
            {
                $this->sessionRDFWriter->addSurveyToPipeline($session[$i.'s'], $i);
            }
            else if(isset($session[$i.'a']))
            {
                $this->sessionRDFWriter->addApplicationToPipeline($session[$i.'a'], $i);
            }
            else if(isset($session[$i.'d'])) 
            {
                $this->sessionRDFWriter->addDashboardToPipeline($session[$i.'d'], $i);
            }
        }
    }
    
    public function getSessionInfo()
    {
        $sessionInfo = array();

        $resultSession = $this->sessionRDFReader->getSurveyInfo();
        
        $sessionInfo['sessionTitle'] = substr($resultSession[0][0]['?title'],9,strlen($resultSession[0][0]['?title'])-11);
        $sessionInfo['sessionDescription'] = substr($resultSession[0][0]['?description'],9,strlen($resultSession[0][0]['?description'])-11);
        
        foreach ($resultSession[1][1] as $surveyInfo) 
        {
             $surveyUID = substr($surveyInfo['?uid'],9,strlen($surveyInfo['?uid'])-11);
             $surveyIndex = substr($surveyInfo['?index'],9,strlen($surveyInfo['?index'])-11);
             $sessionInfo[$surveyIndex . 's'] = $surveyUID;
        }
        foreach ($resultSession[1][2] as $applicationInfo) 
        {
             $applicationUID = substr($applicationInfo['?uid'],9,strlen($applicationInfo['?uid'])-11);
             $applicationIndex = substr($applicationInfo['?index'],9,strlen($applicationInfo['?index'])-11);
             $sessionInfo[$applicationIndex . 'a'] = $applicationUID;
        }
        foreach ($resultSession[1][3] as $dashboardInfo) 
        {
             $dashboardUID = substr($dashboardInfo['?uid'],9,strlen($dashboardInfo['?uid'])-11);
             $dashboardIndex = substr($dashboardInfo['?index'],9,strlen($dashboardInfo['?index'])-11);
             $sessionInfo[$dashboardIndex . 'd'] = $dashboardUID;
        }
    }
    
    public function getExistingSessions()
    {
        $sessionIDs = array();
        $sessions = array();

        if($handle = opendir('data/sessions/'))
        {
            while (false !== ($file = readdir($handle))) {
                if(strstr($file, 'session_'))
                    $sessionIDs[] = substr($file,7,strlen($file)-11);
            }
        }

        foreach($sessionIDs as $sessionID)
        {
            $sessionTitle = $this->sessionRDFReader->getSessionTitleByID($sessionID);
            $$sessions[$sessionID] = substr($sessionTitle[0]['?title'],9,strlen($sessionTitle[0]['?title'])-11);
        }

        return $surveys;
    }
}
?>
